<?php
/**
* Wizard
* @package Whizzie
* @since 1.0.0
*/

class Whizzie {
	protected $version = '1.1.0';
	protected $theme_name = '';
	protected $theme_title = '';
	protected $page_slug = '';
	protected $page_title = '';
	protected $config_steps = array();
	public $parent_slug;
	/**
	 * Constructor
	 * @param $config Configuration parameters
	 */
	public function __construct( $config ) {
		$this->set_vars( $config );
		$this->init();
	}

	/**
	 * Set variables based on configuration
	 * @param $config Configuration parameters
	 */
	public function set_vars( $config ) {
		if ( isset( $config['page_slug'] ) ) {
			$this->page_slug = esc_attr( $config['page_slug'] );
		}
		if ( isset( $config['page_title'] ) ) {
			$this->page_title = esc_attr( $config['page_title'] );
		}
		if ( isset( $config['steps'] ) ) {
			$this->config_steps = $config['steps'];
		}

		$current_theme = wp_get_theme();
		$this->theme_title = $current_theme->get( 'Name' );
		$this->theme_name = strtolower( preg_replace( '#[^a-zA-Z]#', '', $current_theme->get( 'Name' ) ) );
		$this->page_slug = apply_filters( $this->theme_name . '_theme_setup_wizard_page_slug', $this->theme_name . '-wizard' );
		$this->parent_slug = apply_filters( $this->theme_name . '_theme_setup_wizard_parent_slug', '' );
	}

	/*** Initialize hooks and actions ***/
	public function init() {
		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );
		add_action( 'admin_menu', array( $this, 'menu_page' ) );
		add_action( 'wp_ajax_setup_widgets', array( $this, 'setup_widgets' ) );
	}

	public function enqueue_scripts() {
		wp_enqueue_style( 'theme-wizard-style', get_template_directory_uri() . '/theme-wizard/assets/css/theme-wizard-style.css');
		wp_register_script( 'theme-wizard-script', get_template_directory_uri() . '/theme-wizard/assets/js/theme-wizard-script.js', array( 'jquery' ));
		wp_localize_script(
			'theme-wizard-script',
			'construction_engineer_whizzie_params',
			array(
				'ajaxurl' => admin_url( 'admin-ajax.php' ),
				'verify_text' => esc_html( 'verifying', 'construction-engineer' )
			)
		);
		wp_enqueue_script( 'theme-wizard-script' );
	}

	public function menu_page() {
		add_theme_page( esc_html( $this->page_title ), esc_html( $this->page_title ), 'manage_options', $this->page_slug, array( $this, 'construction_engineer_setup_wizard' ) );
	}

	/*** Display the wizard page content ***/
	public function wizard_page() { ?>
		<div class="main-wrap">
			<div class="card whizzie-wrap">
				<ul class="whizzie-menu">
					<?php foreach ( $this->get_steps() as $step ) : ?>
						<li data-step="<?php echo esc_attr( $step['id'] ); ?>" class="step step-<?php echo esc_attr( $step['id'] ); ?>">

							<h2><?php echo esc_html( $step['title'] ); ?></h2>

							<?php
							$content = call_user_func( array( $this, $step['view'] ) );
							?>

							<?php if ( isset( $content['summary'] ) ) : ?>
								<div class="summary">
									<?php echo wp_kses_post( $content['summary'] ); ?>
								</div>
							<?php endif; ?>

							<?php if ( isset( $content['detail'] ) ) : ?>
								<p>
									<a href="#" class="more-info">
										<?php esc_html_e( 'More Info', 'construction-engineer' ); ?>
									</a>
								</p>
								<div class="detail">
									<?php echo wp_kses_post( $content['detail'] ); ?>
								</div>
							<?php endif; ?>

							<?php if ( ! empty( $step['button_text'] ) ) : ?>
								<div class="button-wrap">

									<?php if ( ! get_option( 'is-demo-imported' ) ) : ?>

										<a href="#"
										class="button button-primary do-it"
										data-callback="<?php echo esc_attr( $step['callback'] ); ?>"
										data-step="<?php echo esc_attr( $step['id'] ); ?>">
											<?php echo esc_html( $step['button_text'] ); ?>
										</a>

									<?php else : ?>

										<a target="_blank"
										href="<?php echo esc_url( home_url() ); ?>"
										class="button button-primary"
										style="font-size:20px;font-weight:600;">
											<?php esc_html_e( 'Visit Site', 'construction-engineer' ); ?>
										</a>

									<?php endif; ?>

								</div>
							<?php endif; ?>

						</li>
					<?php endforeach; ?>
				</ul>
				<div class="step-loading">
					<span class="spinner"></span>
				</div>
			</div>
		</div>
	<?php }

	/*** Setup wizard page content and options ***/
	public function construction_engineer_setup_wizard() { ?>
		<div class="wrapper-info get-stared-page-wrap">
			<div class="tab-sec theme-option-tab">
				<div id="demo_offer" class="tabcontent">
					<?php $this->wizard_page(); ?>
				</div>
			</div>
		</div>
	<?php }

	/**
	 * Get the steps for the wizard
	 * @return array
	 */
	public function get_steps() {
		$steps = array(
			'intro' => array(
				'id' => 'intro',
				'title' => __( 'Welcome to ', 'construction-engineer' ) . $this->theme_title,
				'view' => 'get_step_intro',
				'callback' => 'do_next_step',
				'button_text' => __( 'Start Now', 'construction-engineer' ),
				'can_skip' => false
			),
			'widgets' => array(
				'id' => 'widgets',
				'title' => __( 'Demo Importer', 'construction-engineer' ),
				'view' => 'get_step_widgets',
				'callback' => 'install_widgets',
				'button_text' => __( 'Import Demo', 'construction-engineer' ),
				'can_skip' => true
			),
			'done' => array(
				'id' => 'done',
				'title' => __( 'All Done', 'construction-engineer' ),
				'view' => 'get_step_done'
			)
		);

		return $steps;
	}

	/*** Display the content for the intro step ***/
	public function get_step_intro() { ?>
		<div class="summary">
			<p style="text-align: center;"><?php esc_html_e( 'Thank you for choosing our theme! We are excited to help you get started with your new website.', 'construction-engineer' ); ?></p>
			<p style="text-align: center;"><?php esc_html_e( 'This section will guide you through setting up and customizing the theme. You can follow the steps to import demo content or adjust settings at any time to make the website look and work the way you want.', 'construction-engineer' ); ?></p>
		</div>
	<?php }

	/*** Display the content for the widgets step ***/
	public function get_step_widgets() { ?>
		<div class="summary">
			<p><?php esc_html_e('To get started, use the button below to import demo content and add widgets to your site. After installation, you can manage settings and customize your site using the Customizer. Enjoy your new theme!', 'construction-engineer'); ?></p>
		</div>
	<?php }

	/*** Display the content for the final step ***/
	public function get_step_done() { ?>
		<div id="aster-demo-setup-guid">
			<div class="aster-setup-menu">
				<h3><?php esc_html_e('Setup Navigation Menu','construction-engineer'); ?></h3>
				<p><?php esc_html_e('Follow the following Steps to Setup Menu','construction-engineer'); ?></p>
				<h4><?php esc_html_e('A) Create Pages','construction-engineer'); ?></h4>
				<ol>
					<li><?php esc_html_e('Go to Dashboard >> Pages >> Add New','construction-engineer'); ?></li>
					<li><?php esc_html_e('Enter Page Details And Save Changes','construction-engineer'); ?></li>
				</ol>
				<h4><?php esc_html_e('B) Add Pages To Menu','construction-engineer'); ?></h4>
				<ol>
					<li><?php esc_html_e('Go to Dashboard >> Appearance >> Menu','construction-engineer'); ?></li>
					<li><?php esc_html_e('Click On The Create Menu Option','construction-engineer'); ?></li>
					<li><?php esc_html_e('Select The Pages And Click On The Add to Menu Button','construction-engineer'); ?></li>
					<li><?php esc_html_e('Select Primary Menu From The Menu Setting','construction-engineer'); ?></li>
					<li><?php esc_html_e('Click On The Save Menu Button','construction-engineer'); ?></li>
				</ol>
			</div>
			<div class="aster-setup-widget">
				<h3><?php esc_html_e('Setup Footer Widgets','construction-engineer'); ?></h3>
				<p><?php esc_html_e('Follow the following Steps to Setup Footer Widgets','construction-engineer'); ?></p>
				<ol>
					<li><?php esc_html_e('Go to Dashboard >> Appearance >> Widgets','construction-engineer'); ?></li>
					<li><?php esc_html_e('Drag And Add The Widgets In The Footer Columns','construction-engineer'); ?></li>
				</ol>
			</div>
			<div style="display:flex; flex-wrap: wrap; justify-content: center; margin-top: 20px; gap:20px">
				<div class="aster-setup-finish">
					<a target="_blank" href="<?php echo esc_url(home_url()); ?>" class="button button-primary">Visit Site</a>
				</div>
				<div class="aster-setup-finish">
					<a target="_blank" href="<?php echo esc_url( admin_url('customize.php') ); ?>" class="button button-primary">Customize Your Demo</a>
				</div>
				<div class="aster-setup-finish">
					<a target="_blank" href="<?php echo esc_url( admin_url('themes.php?page=construction-engineer-getting-started') ); ?>" class="button button-primary">Dashboard</a>
				</div>
			</div>
		</div>
	<?php }


	//                      ------------- MENUS -----------------                    //

	public function construction_engineer_customizer_primary_menu(){
		// ------- Create Primary Menu --------
		$construction_engineer_themename = 'Construction Engineer'; // Ensure the theme name is set
		$construction_engineer_menuname = $construction_engineer_themename . ' Primary Menu';
		$construction_engineer_bpmenulocation = 'primary';
		$construction_engineer_menu_exists = wp_get_nav_menu_object($construction_engineer_menuname);
	
		if( !$construction_engineer_menu_exists ) {
			$construction_engineer_menu_id = wp_create_nav_menu($construction_engineer_menuname);
			
			// Home
			wp_update_nav_menu_item($construction_engineer_menu_id, 0, array(
				'menu-item-title' => __('Home', 'construction-engineer'),
				'menu-item-classes' => 'home',
				'menu-item-url' => home_url('/'),
				'menu-item-status' => 'publish'
			));
	
			// About Us
			$page_about = get_page_by_path('about'); // Preferred over get_page_by_title()
			if($page_about){
				wp_update_nav_menu_item($construction_engineer_menu_id, 0, array(
					'menu-item-title' => __('About Us', 'construction-engineer'),
					'menu-item-classes' => 'about',
					'menu-item-url' => get_permalink($page_about),
					'menu-item-status' => 'publish'
				));
			}
	
			// Services
			$page_services = get_page_by_path('services');
			if($page_services){
				wp_update_nav_menu_item($construction_engineer_menu_id, 0, array(
					'menu-item-title' => __('Services', 'construction-engineer'),
					'menu-item-classes' => 'services',
					'menu-item-url' => get_permalink($page_services),
					'menu-item-status' => 'publish'
				));
			}
	
			// News
			$page_news = get_page_by_path('news');
			if($page_news){
				wp_update_nav_menu_item($construction_engineer_menu_id, 0, array(
					'menu-item-title' => __('News', 'construction-engineer'),
					'menu-item-classes' => 'news',
					'menu-item-url' => get_permalink($page_news),
					'menu-item-status' => 'publish'
				));
			}

			// Blog
			$page_blog = get_page_by_path('blog');
			if($page_blog){
				wp_update_nav_menu_item($construction_engineer_menu_id, 0, array(
					'menu-item-title' => __('Blog', 'construction-engineer'),
					'menu-item-classes' => 'blog',
					'menu-item-url' => get_permalink($page_blog),
					'menu-item-status' => 'publish'
				));
			}
	
			// Assign menu to location if not set
			if( !has_nav_menu($construction_engineer_bpmenulocation) ){
				$locations = get_theme_mod('nav_menu_locations');
				$locations[$construction_engineer_bpmenulocation] = $construction_engineer_menu_id;
				set_theme_mod('nav_menu_locations', $locations);
			}
		}
	}


	//                      ------------- /*** Imports demo content ***/ -----------------                    //

	public function setup_widgets() {

		// Create a front page and assign the template
		$construction_engineer_home_title = 'Home';
		$construction_engineer_home_check = get_page_by_path('home');
		if (!$construction_engineer_home_check) {
			$construction_engineer_home = array(
				'post_type'    => 'page',
				'post_title'   => $construction_engineer_home_title,
				'post_status'  => 'publish',
				'post_author'  => 1,
				'post_name'    => 'home' // Unique slug for the home page
			);
			$construction_engineer_home_id = wp_insert_post($construction_engineer_home);

			// Set the static front page
			if (!is_wp_error($construction_engineer_home_id)) {
				update_option('page_on_front', $construction_engineer_home_id);
				update_option('show_on_front', 'page');
			}
		}

		// Create a posts page and assign the template
		$construction_engineer_blog_title = 'Blog';
		$construction_engineer_blog_check = get_page_by_path('blog');
		if (!$construction_engineer_blog_check) {
			$construction_engineer_blog = array(
				'post_type'    => 'page',
				'post_title'   => $construction_engineer_blog_title,
				'post_status'  => 'publish',
				'post_author'  => 1,
				'post_name'    => 'blog' // Unique slug for the blog page
			);
			$construction_engineer_blog_id = wp_insert_post($construction_engineer_blog);

			// Set the posts page
			if (!is_wp_error($construction_engineer_blog_id)) {
				update_option('page_for_posts', $construction_engineer_blog_id);
			}
		}

		// Create a About Us page and assign the template
		$construction_engineer_pages_title = 'About Us';
		$construction_engineer_pages_check = get_page_by_path('about');
		if (!$construction_engineer_about_check) {
			$construction_engineer_about = array(
				'post_type'    => 'page',
				'post_title'   => $construction_engineer_about_title,
				'post_content' => '<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry standard dummy text ever since the 1500, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960 with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.</p>',
				'post_status'  => 'publish',
				'post_author'  => 1,
				'post_name'    => 'about' // Unique slug for the About Us page
			);
			wp_insert_post($construction_engineer_about);
		}

		// Create a Services page and assign the template
		$construction_engineer_services_title = 'Services';
		$construction_engineer_services_check = get_page_by_path('services');
		if (!$construction_engineer_services_check) {
			$construction_engineer_services = array(
				'post_type'    => 'page',
				'post_title'   => $construction_engineer_services_title,
				'post_content' => '<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry standard dummy text ever since the 1500, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960 with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.</p>',
				'post_status'  => 'publish',
				'post_author'  => 1,
				'post_name'    => 'services' // Unique slug for the Services page
			);
			wp_insert_post($construction_engineer_services);
		}

		// Create a News page and assign the template
		$construction_engineer_news_title = 'News';
		$construction_engineer_news_check = get_page_by_path('news');
		if (!$construction_engineer_news_check) {
			$construction_engineer_news = array(
				'post_type'    => 'page',
				'post_title'   => $construction_engineer_news_title,
				'post_content' => '<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry standard dummy text ever since the 1500, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960 with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.</p>',
				'post_status'  => 'publish',
				'post_author'  => 1,
				'post_name'    => 'news' // Unique slug for the News page
			);
			wp_insert_post($construction_engineer_news);
		}


		/*----------------------------------------- Header Button --------------------------------------------------*/

			set_theme_mod( 'construction_engineer_header_button_label_','Get Appointment');
			set_theme_mod( 'construction_engineer_header_button_link_','#');
			

		// ------------------------------------------ Blogs for Sections --------------------------------------

			// Create categories if not already created
			$construction_engineer_category_slider = wp_create_category('Slider');
			$construction_engineer_category_services = wp_create_category('Services');

			// Array of categories to assign to each set of posts
			$construction_engineer_categories = array($construction_engineer_category_slider, $construction_engineer_category_services);

			// Loop to create posts
			for ($i = 1; $i <= 4; $i++) {
				$title = array(
					'Your Gateway To Engineering Excellence',
					'Building the Future, One Structure at a Time',
					'Engineering Strength, Constructing Success',
					'We Transform Ideas To Tangile Reality',
				);

				$content = 'Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry standard dummy text ever since.';

				// Determine category and post index to use for title
				$category_index = ($i <= 3) ? 0 : 1; // First 3 for Slider, next 3 for Blog
				$post_title = $title[$i - 1]; // Adjust for zero-based index in title array

				// Create post object
				$my_post = array(
					'post_title'    => wp_strip_all_tags($post_title),
					'post_content'  => $content,
					'post_status'   => 'publish',
					'post_type'     => 'post',
					'post_category' => array($construction_engineer_categories[$category_index]), // Assign Slider to first 3, Blog to next 3
				);

				// Insert the post into the database
				$post_id = wp_insert_post($my_post);

				// Determine the category and set image URLs based on category
				if ($category_index === 0) { // Slider category
					$slider_index = $i % 3 + 1; // Cycles through 1, 2, 3
					$construction_engineer_image_url = get_template_directory_uri() . "/resource/img/slider{$slider_index}.png";
					$construction_engineer_image_name = "slider{$slider_index}.png";
				} else { // Blog category
					$construction_engineer_image_url = get_template_directory_uri() . '/resource/img/service.png';
					$construction_engineer_image_name = 'service.png';
				}

				$construction_engineer_upload_dir = wp_upload_dir();
				$construction_engineer_image_data = file_get_contents($construction_engineer_image_url);
				$construction_engineer_unique_file_name = wp_unique_filename($construction_engineer_upload_dir['path'], $construction_engineer_image_name);
				$filename = basename($construction_engineer_unique_file_name);

				if (wp_mkdir_p($construction_engineer_upload_dir['path'])) {
					$file = $construction_engineer_upload_dir['path'] . '/' . $filename;
				} else {
					$file = $construction_engineer_upload_dir['basedir'] . '/' . $filename;
				}

				if ( ! function_exists( 'WP_Filesystem' ) ) {
					require_once( ABSPATH . 'wp-admin/includes/file.php' );
				}
				
				WP_Filesystem();
				global $wp_filesystem;
				
				if ( ! $wp_filesystem->put_contents( $file, $construction_engineer_image_data, FS_CHMOD_FILE ) ) {
					wp_die( 'Error saving file!' );
				}

				$wp_filetype = wp_check_filetype($filename, null);
				$attachment = array(
					'post_mime_type' => $wp_filetype['type'],
					'post_title'     => sanitize_file_name($filename),
					'post_content'   => '',
					'post_status'    => 'inherit'
				);

				$construction_engineer_attach_id = wp_insert_attachment($attachment, $file, $post_id);

				require_once(ABSPATH . 'wp-admin/includes/image.php');

				$construction_engineer_attach_data = wp_generate_attachment_metadata($construction_engineer_attach_id, $file);
				wp_update_attachment_metadata($construction_engineer_attach_id, $construction_engineer_attach_data);
				set_post_thumbnail($post_id, $construction_engineer_attach_id);
			}

		
		// ---------------------------------------- Slider --------------------------------------------------- //

			set_theme_mod('construction_engineer_enable_banner_section', true);
			set_theme_mod('construction_engineer_enable_service_section', true);
			for($i=1; $i<=3; $i++) {
				set_theme_mod('construction_engineer_banner_button_label_'.$i,'Learn More');
				set_theme_mod('construction_engineer_banner_button_link_'.$i,'');
				set_theme_mod('construction_engineer_banner_second_button_label_'.$i,'Contact Us');
				set_theme_mod('construction_engineer_banner_second_button_link_'.$i,'');
				set_theme_mod('construction_engineer_banner_short_heading_1'.$i,'Good Construction');
				set_theme_mod('construction_engineer_banner_short_heading_2'.$i,'Good Renovation');
				set_theme_mod('construction_engineer_banner_short_heading_3'.$i,'Good Engineering');
			}


		// ---------------------------------------- Services --------------------------------------------------- //

			set_theme_mod('construction_engineer_trending_product_heading','About Engineering Work');

			$abt_points = array('A Full Services','Our Work Growth','All Maintainance','Service Management');

			for ($i=1; $i<=4; $i++) {
				set_theme_mod('construction_engineer_trending_product_content'.$i,$abt_points[$i-1]);
			}


		// ---------------------------------------- Footer section --------------------------------------------------- //	
		
			set_theme_mod('construction_engineer_footer_background_color_setting','#000000');
			
		// ---------------------------------------- Related post_tag --------------------------------------------------- //	
		
			set_theme_mod('construction_engineer_post_related_post_label','Related Posts');
			set_theme_mod('construction_engineer_related_posts_count','3');


		$this->construction_engineer_customizer_primary_menu();
		update_option('is-demo-imported', true);
	}
}